import javafx.scene.image.Image;
import javafx.scene.input.KeyCode;
import javafx.scene.layout.Pane;
import java.net.URL;
import java.util.Scanner;
import javafx.application.Application;
import javafx.application.Platform;
import javafx.beans.property.SimpleIntegerProperty;
import javafx.scene.Scene;
import javafx.stage.Stage;

public class Assign9 extends Application {

	@Override
	public void start(Stage primaryStage) {
		try {
			//create scanner from url
			URL url = new URL("http://web.cs.sunyit.edu/~realemj/2016fall/Map01.txt");
			Scanner file = new Scanner(url.openStream());
			
			//create map, load map and create mapPane with map
			Map map = new Map();
			map.load(file);
			MapPane mapPane = new MapPane(map);
			
			//create new Pane and add mapPane to the Pane
			Pane displayPane = new Pane();
			displayPane.getChildren().add(mapPane);
			
			//create player with starting position of 5,5 -- create a playerPaner and add to Pane
			Player player = new Player(new SimpleIntegerProperty(5), new SimpleIntegerProperty(5));
			PlayerPane playerPane = new PlayerPane(player);
			displayPane.getChildren().add(playerPane);
			
			//set screen to displayPane and the size to be the appropriate size
			Scene scene = new Scene(displayPane, (map.getX()*32), (map.getY()*32));
			
			//when key pressed...
			scene.setOnKeyPressed(e -> {
				int xCheck = player.getXProperty().intValue();
				int yCheck = player.getYProperty().intValue();
				
				if(e.getCode() == KeyCode.A){ //move left
					xCheck=xCheck-1;
				}
				else if(e.getCode() == KeyCode.D){ //move right
					xCheck=xCheck+1;
				}
				else if(e.getCode() == KeyCode.W){ //move up
					yCheck=yCheck-1;
				}
				else if(e.getCode() == KeyCode.S){ //move down
					yCheck=yCheck+1;
				}
				
				//check player can move to desired location
				if(map.canMoveTo(xCheck, yCheck)){
					player.setPlayerPos(xCheck, yCheck);
				}
			});
			
			//set the icon of the application and the tile ... set scene to stage and show
			primaryStage.getIcons().add(new Image("http://people.sunyit.edu/~greenli/classes/CS249/nethack.png"));
			primaryStage.setTitle("NetHack");
			primaryStage.setScene(scene);
			primaryStage.show();
		}
		catch(Exception e){
			e.printStackTrace();
			Platform.exit();
		}
	}

	public static void main(String [] args) {
		launch(args);
	}
}